/*
 * Copyright (C) 2014 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.graphab;

import it.geosolutions.jaiext.range.NoDataContainer;
import java.awt.CardLayout;
import java.awt.Cursor;
import java.awt.image.DataBuffer;
import java.awt.image.RenderedImage;
import java.io.File;
import java.io.IOException;
import java.util.HashSet;
import java.util.TreeSet;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.media.jai.iterator.RandomIter;
import javax.media.jai.iterator.RandomIterFactory;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import org.geotools.coverage.grid.GridCoverage2D;
import org.geotools.coverage.util.CoverageUtilities;
import org.geotools.feature.SchemaException;
import org.thema.common.Config;
import org.thema.data.IOImage;
import org.thema.graphab.habitat.AbstractMonoHabitat;
import org.thema.graphab.util.RSTGridReader;

/**
 * Dailog form for creating a new project.
 * 
 * @author Gilles Vuidel
 */
public class NewProjectDialog extends javax.swing.JDialog {

    private static final int NBPANEL = 3;
    private int indPanel;

    /** has user validated the form ? */
    public boolean isOk = false;

    private TreeSet<Integer> codes;
    private File imgFile;
    private GridCoverage2D coverage;


    /** 
     * Creates new form NewProjectDialog
     * @param parent the parent frame
     */
    public NewProjectDialog(java.awt.Frame parent) {
        super(parent, true);
        initComponents();
        setLocationRelativeTo(parent);

        prjNameTextField.getDocument().addDocumentListener(new DocumentListener() {
            @Override
            public void changedUpdate(DocumentEvent e) { 
                update(); 
            }
            @Override
            public void removeUpdate(DocumentEvent e) { 
                update();  
            }
            @Override
            public void insertUpdate(DocumentEvent e) { 
                update();  
            }
            private void update() {
                String rep = prjPathTextField.getText();
                rep = rep.substring(0, rep.lastIndexOf(File.separator)+1);
                prjPathTextField.setText(rep + prjNameTextField.getText());
            }
            });
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        connexButtonGroup = new javax.swing.ButtonGroup();
        globalPanel = new javax.swing.JPanel();
        panel1 = new javax.swing.JPanel();
        prjNameLabel = new javax.swing.JLabel();
        prjNameTextField = new javax.swing.JTextField();
        prjPathLabel = new javax.swing.JLabel();
        prjPathTextField = new javax.swing.JTextField();
        selectPathButton = new javax.swing.JButton();
        imgSelectFilePanel = new org.thema.common.swing.SelectFilePanel();
        noDataComboBox = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        panel2 = new org.thema.graphab.habitat.HabitatPanel();
        panel3 = new org.thema.graphab.links.LinksetPanel();
        cancelButton = new javax.swing.JButton();
        prevButton = new javax.swing.JButton();
        nextButton = new javax.swing.JButton();
        endButton = new javax.swing.JButton();

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle"); // NOI18N
        setTitle(bundle.getString("NewProjectDialog.title")); // NOI18N

        globalPanel.setLayout(new java.awt.CardLayout());

        prjNameLabel.setText(bundle.getString("NewProjectDialog.prjNameLabel.text")); // NOI18N

        prjNameTextField.setText(bundle.getString("NewProjectDialog.prjNameTextField.text")); // NOI18N

        prjPathLabel.setText(bundle.getString("NewProjectDialog.prjPathLabel.text")); // NOI18N

        selectPathButton.setText("..."); // NOI18N
        selectPathButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectPathButtonActionPerformed(evt);
            }
        });

        imgSelectFilePanel.setDescription(bundle.getString("NewProjectDialog.imgSelectFilePanel.description")); // NOI18N
        imgSelectFilePanel.setFileDesc(bundle.getString("NewProjectDialog.imgSelectFilePanel.fileDesc_1")); // NOI18N
        imgSelectFilePanel.setFileExts(bundle.getString("NewProjectDialog.imgSelectFilePanel.fileExts_1")); // NOI18N
        imgSelectFilePanel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                imgSelectFilePanelActionPerformed(evt);
            }
        });

        jLabel3.setText(bundle.getString("NewProjectDialog.jLabel3.text_1")); // NOI18N

        javax.swing.GroupLayout panel1Layout = new javax.swing.GroupLayout(panel1);
        panel1.setLayout(panel1Layout);
        panel1Layout.setHorizontalGroup(
            panel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panel1Layout.createSequentialGroup()
                        .addGroup(panel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(prjNameLabel)
                            .addComponent(prjPathLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(panel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(panel1Layout.createSequentialGroup()
                                .addComponent(prjPathTextField)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(selectPathButton, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(prjNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 130, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(imgSelectFilePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 452, Short.MAX_VALUE))
                .addContainerGap())
            .addGroup(panel1Layout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(noDataComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(163, 163, 163))
        );
        panel1Layout.setVerticalGroup(
            panel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panel1Layout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addGroup(panel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(prjNameLabel)
                    .addComponent(prjNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(prjPathLabel)
                    .addComponent(prjPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(selectPathButton))
                .addGap(33, 33, 33)
                .addComponent(imgSelectFilePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(panel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(noDataComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        globalPanel.add(panel1, "panel1");
        globalPanel.add(panel2, "card5");
        globalPanel.add(panel3, "panel3");

        cancelButton.setText(bundle.getString("NewProjectDialog.cancelButton.text")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        prevButton.setText(bundle.getString("NewProjectDialog.prevButton.text")); // NOI18N
        prevButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                prevButtonActionPerformed(evt);
            }
        });

        nextButton.setText(bundle.getString("NewProjectDialog.nextButton.text")); // NOI18N
        nextButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nextButtonActionPerformed(evt);
            }
        });

        endButton.setText(bundle.getString("NewProjectDialog.endButton.text")); // NOI18N
        endButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                endButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(97, Short.MAX_VALUE)
                .addComponent(cancelButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(prevButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(nextButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(endButton)
                .addContainerGap())
            .addComponent(globalPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(globalPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 524, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(endButton)
                    .addComponent(cancelButton)
                    .addComponent(prevButton)
                    .addComponent(nextButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
        dispose();
}//GEN-LAST:event_cancelButtonActionPerformed

    private void prevButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_prevButtonActionPerformed
        prevPanel();
}//GEN-LAST:event_prevButtonActionPerformed

    private void nextButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextButtonActionPerformed
        if(validatePanel()) {
            nextPanel();
        }
}//GEN-LAST:event_nextButtonActionPerformed

    private void endButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_endButtonActionPerformed
        if(validatePanel()) {
            isOk = true;
            setVisible(false);
            dispose();
        }
    }//GEN-LAST:event_endButtonActionPerformed

    private void selectPathButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectPathButtonActionPerformed
        JFileChooser fileDlg = new JFileChooser(prjPathTextField.getText());
        fileDlg.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

        if(fileDlg.showOpenDialog(this) == JFileChooser.CANCEL_OPTION) {
            return;
        }

        prjPathTextField.setText(fileDlg.getSelectedFile().getPath() + File.separator + prjNameTextField.getText());
    }//GEN-LAST:event_selectPathButtonActionPerformed

    private void imgSelectFilePanelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_imgSelectFilePanelActionPerformed
        imgFile = imgSelectFilePanel.getSelectedFile();
        if(imgFile == null) {
            return;
        }
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        try {
            if(imgFile.getName().toLowerCase().endsWith(".rst")) { //NOI18N
                coverage = new RSTGridReader(imgFile).read(null);
            } else {
                coverage = IOImage.loadCoverage(imgFile);
            }
            
            int dataType = coverage.getRenderedImage().getSampleModel().getDataType();
            if(dataType == DataBuffer.TYPE_DOUBLE || dataType == DataBuffer.TYPE_FLOAT) {
                throw new RuntimeException(java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("IMAGE DATA TYPE IS NOT INTEGER TYPE"));
            }
            
            codes = getCodes(coverage);
            panel2.setCodes(codes);
            DefaultComboBoxModel model = new DefaultComboBoxModel(codes.toArray());
            model.insertElementAt("(None)", 0);
            noDataComboBox.setModel(model);
            NoDataContainer noDataProp = CoverageUtilities.getNoDataProperty(coverage);
            if(noDataProp != null && !Double.isNaN(noDataProp.getAsSingleValue())) {
                int val = (int)noDataProp.getAsSingleValue();
                noDataComboBox.setSelectedItem(val);
            }
            noDataComboBox.setSelectedIndex(0);

        } catch (IOException | RuntimeException ex) {
            Logger.getLogger(NewProjectDialog.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, java.text.MessageFormat.format(java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("ERROR WHILE LOADING IMAGE FILE\\N{0}"), ex.getLocalizedMessage()));
            imgSelectFilePanel.setSelectedFile(null);
        }
        
        setCursor(Cursor.getDefaultCursor());
}//GEN-LAST:event_imgSelectFilePanelActionPerformed

    /**
     * 
     * @param cov the landscape map
     * @return the set of values contained in this coverage
     */
    public static TreeSet<Integer> getCodes(GridCoverage2D cov) {
        HashSet<Integer> codes = new HashSet<>();
        RenderedImage img = cov.getRenderedImage();
        RandomIter r = RandomIterFactory.create(img, null);
        for(int y = 0; y < img.getHeight(); y++) {
            for(int x = 0; x < img.getWidth(); x++) {
                codes.add(r.getSample(x, y, 0));
            }
        }

        return new TreeSet<>(codes);
    }

    private boolean validatePanel() {
        switch(indPanel) {
            case 0:
                if(prjNameTextField.getText().isEmpty()) {
                    JOptionPane.showMessageDialog(this, java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("PROJECT'S NAME IS EMPTY."), java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("ERROR"), JOptionPane.ERROR_MESSAGE);
                    return false;
                }
                if(prjPathTextField.getText().isEmpty()) {
                    JOptionPane.showMessageDialog(this, java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("PATH IS EMPTY."), java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("ERROR"), JOptionPane.ERROR_MESSAGE);
                    return false;
                }
                String rep = prjPathTextField.getText();
                rep = rep.substring(0, rep.lastIndexOf(File.separator));
                File fRep = new File(rep);
                if(!fRep.exists() || !fRep.isDirectory()) {
                    JOptionPane.showMessageDialog(this, java.text.MessageFormat.format(java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("FOLDER {0} DOES NOT EXIST."), new Object[] {rep}), java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("ERROR"), JOptionPane.ERROR_MESSAGE);
                    return false;
                }
                Config.setDir(fRep.getAbsolutePath());
                
                fRep = new File(prjPathTextField.getText());
                if(fRep.exists()) {
                    if(!fRep.isDirectory()){
                        JOptionPane.showMessageDialog(this, fRep.getAbsolutePath() + java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString(" IS NOT A DIRECTORY"), java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("ERROR"), JOptionPane.ERROR_MESSAGE);
                        return false;
                    }
                    if(!fRep.canRead() || !fRep.canWrite() || !fRep.canExecute()){
                        JOptionPane.showMessageDialog(this, java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("GRAPHAB HAS NO RIGHT TO ACCESS FOLDER ")+fRep.getAbsolutePath(), java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("ERROR"), JOptionPane.ERROR_MESSAGE);
                        return false;
                    }
                    if(fRep.list().length > 0) {
                        if(JOptionPane.showConfirmDialog(this,
                                java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("PROJECT DIRECTORY IS NOT EMPTY\\NDO YOU WANT TO CONTINUE ?"),
                                java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("WARNING"), JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION) {
                            return false;
                        }
                    }
                }
                if(coverage == null) {
                    JOptionPane.showMessageDialog(this, java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("YOU HAVE TO SELECT A RASTER FILE FOR LANDSCAPE MAP"), java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("ERROR"), JOptionPane.ERROR_MESSAGE);
                    return false;
                }
                double noData = noDataComboBox.getSelectedIndex() == 0 ? Double.NaN : ((Number)noDataComboBox.getSelectedItem()).doubleValue();
                TreeSet<Integer> newCodes = new TreeSet<>(codes);
                if(!Double.isNaN(noData)) {
                    newCodes.remove((int)noData);
                }
                panel3.setCodes(newCodes, null);
                return true;
            case 1:
                if(!panel2.validatePanel()) {
                    return false;
                }
                if(panel2.getHabitatCodes().contains(noDataComboBox.getSelectedItem())) {
                    JOptionPane.showMessageDialog(this, java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("HABITAT CODES CONTAIN NODATA CODE."), java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle").getString("ERROR"), JOptionPane.ERROR_MESSAGE);
                    return false;
                }
                return true;

            default:
                return true;

        }
     
    }

    private void nextPanel() {
        indPanel++;

        if(indPanel >= NBPANEL) {
            indPanel = NBPANEL-1;
            return;
        }
        
        nextButton.setEnabled(indPanel < NBPANEL-1);
        prevButton.setEnabled(indPanel > 0);
        
        ((CardLayout)globalPanel.getLayout()).next(globalPanel);
    }

    private void prevPanel() {
        indPanel--;

        if(indPanel < 0) {
            indPanel = 0;
            return;
        }
        
        nextButton.setEnabled(indPanel < NBPANEL-1);
        prevButton.setEnabled(indPanel > 0);
        
        ((CardLayout)globalPanel.getLayout()).previous(globalPanel);
    }
    
    /**
     * Creates the project after the user has validated the form.
     * isOk must be true
     * @return the new created project
     * @throws IOException
     * @throws SchemaException 
     */
    public Project createProject() throws IOException, SchemaException {
        File prjPath = new File(prjPathTextField.getText());
        double noData = noDataComboBox.getSelectedIndex() == 0 ? Double.NaN : ((Number)noDataComboBox.getSelectedItem()).doubleValue();
        Project prj = new Project(prjNameTextField.getText(), prjPath, coverage, codes, noData);
        
        if(indPanel >= 1) {
            panel2.setProject(prj);
            AbstractMonoHabitat habitat = panel2.getHabitat();
            prj.addHabitat(habitat, true);
            if(indPanel == 2) {
                panel3.setProject(prj);
                prj.addLinkset(panel3.getLinkset(habitat, false), true);
            }
        }
        
        return prj;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.ButtonGroup connexButtonGroup;
    private javax.swing.JButton endButton;
    private javax.swing.JPanel globalPanel;
    private org.thema.common.swing.SelectFilePanel imgSelectFilePanel;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JButton nextButton;
    private javax.swing.JComboBox noDataComboBox;
    private javax.swing.JPanel panel1;
    private org.thema.graphab.habitat.HabitatPanel panel2;
    private org.thema.graphab.links.LinksetPanel panel3;
    private javax.swing.JButton prevButton;
    private javax.swing.JLabel prjNameLabel;
    private javax.swing.JTextField prjNameTextField;
    private javax.swing.JLabel prjPathLabel;
    private javax.swing.JTextField prjPathTextField;
    private javax.swing.JButton selectPathButton;
    // End of variables declaration//GEN-END:variables

}
